
AWSTemplateFormatVersion: 2010-09-09
Description: >-
  AWS CloudFormation VPC Template


Parameters:
  VpcCidrBlock:
    Type: String
    Default: 10.0.0.0/16
    Description: Enter the main VPC CIDR block.


Resources:
#Creation du VPC et des subnets
  MyVPC:
    Type: AWS::EC2::VPC
    Properties:
      CidrBlock: !Ref VpcCidrBlock
      Tags:
        - Key: Name
          Value: 'MainVPC'

  PrivateSubnetA:
    Type: AWS::EC2::Subnet
    Properties:
      AvailabilityZone: !Select [ 0, Fn::GetAZs: !Ref 'AWS::Region']
      CidrBlock: !Select [ 0, !Cidr [ !GetAtt MyVPC.CidrBlock, 1, 8 ] ]
      Tags:
        - Key: Name
          Value: 'MainVPC-private-a'
      VpcId: !Ref MyVPC

  PublicSubnetA:
    Type: AWS::EC2::Subnet
    Properties:
      AvailabilityZone: !Select [ 0, Fn::GetAZs: !Ref 'AWS::Region']
      CidrBlock: !Select [ 1, !Cidr [ !GetAtt MyVPC.CidrBlock, 2, 8 ] ]
      Tags:
        - Key: Name
          Value: 'MainVPC-public-a'
      VpcId: !Ref MyVPC

  PublicSubnetB:
    Type: AWS::EC2::Subnet
    Properties:
      AvailabilityZone: !Select [ 1, Fn::GetAZs: !Ref 'AWS::Region']
      #Exemple de calcul de bloc CIDR auto à partir de celui du VPC qui donnera 10.0.1.0/24
      CidrBlock: !Select [ 2, !Cidr [ !GetAtt MyVPC.CidrBlock, 3, 8 ] ]
      Tags:
        - Key: Name
          Value: 'MainVPC-public-b'
      VpcId: !Ref MyVPC

#Creation de l'internet Gateway du VPC
  InternetGateway:
    Type: AWS::EC2::InternetGateway
    Properties:
      Tags:
        - Key: Name
          Value: 'MainVPC-InternetGateway'

  AttachInternetGateway:
    Type: AWS::EC2::VPCGatewayAttachment
    Properties:
      VpcId: !Ref MyVPC
      InternetGatewayId: !Ref InternetGateway


#Creation IP Elastic et NAT Gateway
  IpElasticA:
    Type: AWS::EC2::EIP
    Properties:
      Domain: vpc

  NatGatewayA:
    DependsOn: AttachInternetGateway
    Type: AWS::EC2::NatGateway
    Properties:
      AllocationId: !GetAtt IpElasticA.AllocationId
      SubnetId: !Ref PublicSubnetA
      Tags:
        - Key: Name
          Value: MainVPC-nat-a

#Creation Tables-routage-PublicA et routes
  PublicRouteTable:
    Type: AWS::EC2::RouteTable
    Properties:
      VpcId: !Ref MyVPC
      Tags:
        - Key: Name
          Value: MainVPC-route-public-a

  AttachPublicRouteTable1:
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      RouteTableId: !Ref PublicRouteTable
      SubnetId: !Ref PublicSubnetA

  AttachPublicRouteTable2:
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      RouteTableId: !Ref PublicRouteTable
      SubnetId: !Ref PublicSubnetB

  routeIPv4A:
    Type: AWS::EC2::Route
    Properties:
      DestinationCidrBlock: 0.0.0.0/0
      GatewayId: !Ref InternetGateway
      RouteTableId: !Ref PublicRouteTable

  routeIPv6A:
    Type: AWS::EC2::Route
    Properties:
      DestinationIpv6CidrBlock: ::/0
      GatewayId: !Ref InternetGateway
      RouteTableId: !Ref PublicRouteTable

#Creation Tables-routage-PrivéeA et routes
  PrivateRouteTable:
    Type: AWS::EC2::RouteTable
    Properties:
      VpcId: !Ref MyVPC
      Tags:
        - Key: Name
          Value: MainVPC-route-private-a

  AttachPrivateRouteTable:
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      RouteTableId: !Ref PrivateRouteTable
      SubnetId: !Ref PrivateSubnetA

  routeIPv4B:
    Type: AWS::EC2::Route
    Properties:
      DestinationCidrBlock: 0.0.0.0/0
      NatGatewayId: !Ref NatGatewayA
      RouteTableId: !Ref PrivateRouteTable

Outputs:
  VPC:
    Description: The ID of the VPC
    Value: !Ref MyVPC
    Export:
      Name: !Sub "${AWS::StackName}-vpc-id"
  CidrBlockVPC:
    Description: The ID of the VPC
    Value: !GetAtt MyVPC.CidrBlock
    Export:
      Name: !Sub "${AWS::StackName}-vpc-cidr"
  PublicSubnets:
    Description: List of public subnets ID
    Value: !Join
      - ','
      - [!Ref PublicSubnetA,!Ref PublicSubnetB]
    Export:
      Name: !Sub "${AWS::StackName}-subnet-public-listId"
  PrivateSubnets:
    Description: List of private subnets ID
    Value: !Join
      - ','
      - [ !Ref PrivateSubnetA]
    Export:
      Name: !Sub "${AWS::StackName}-subnet-private-listId"


